local ItemOwner = {}
ItemOwner.NAME = "Item Owner";
ItemOwner.AUTHOR = "Shuazi";
ItemOwner.VERSION = "1.0.0";

print("Mod Loaded: " .. ItemOwner.NAME .. " by " .. ItemOwner.AUTHOR .. " (v" .. ItemOwner.VERSION .. ")");

function ItemOwner.loadData(item)
	if item:getModData()['_I'] == nil or item:getModData()['_O'] == nil then
    item:getModData()['_I'] = getCurrentUserSteamID()
    item:getModData()['_O'] = getOnlineUsername()
  end
end

function ItemOwner.HandleItem(item)
  if item:getCategory() == "Container" then
    if item:getFullType() == "Hydrocraft.HCWagonoxen" then
      item:setCapacity(400);
    end
    if item:getWeightReduction() >= 100 then
      item:setWeightReduction(100);
    end
  end
end

function ItemOwner.HandleFloorItem()
  local cell = getWorld():getCell()
  local char = getPlayer()
  local x = char:getX()
  local y = char:getY()
  local z = char:getZ()
  for dy = -1, 1 do
    for dx = -1, 1 do
      local sq = cell:getGridSquare(x + dx, y + dy, z)
      if sq ~= nil then
        for i = sq:getObjects():size(), 1, -1 do
          local obj = sq:getObjects():get(i - 1)
          if instanceof(obj, 'IsoWorldInventoryObject') then
            ItemOwner.loadData(obj:getItem())
          end
        end
      end
    end
  end
end

function ItemOwner.IsActive()
  local GameMode = getCore():getGameMode()
  local SteamMode = getSteamModeActive()
  if GameMode == "Multiplayer" and SteamMode then
    return true
    else
    Events.OnPlayerMove.Remove(ItemOwner.HandleFloorItem)
    return false
  end
end

local render = ISToolTipInv.render
function ISToolTipInv:render()
  if not ItemOwner.IsActive() then
    render(self)
    return
  end
  local modData = self.item:getModData()
  local inventory = getPlayer():getInventory()
  local items = inventory:getItems()
  for i = 0, items:size() - 1 do
    if items:get(i):getCategory() == "Container" then
      if items:get(i):getInventory():contains(self.item) then
        ItemOwner.HandleItem(self.item)
        ItemOwner.loadData(self.item)
      end
    end
  end
  
  
  if inventory:contains(self.item) then
    ItemOwner.HandleItem(self.item)
    ItemOwner.loadData(self.item)
  end
  
  
  local owner_text = getText("Tooltip_item_Owner")
  local id_text = getText("Tooltip_item_ID")
  if modData["_O"] ~= nil then
    owner_text = owner_text .. modData["_O"]
  end
  if modData["_I"] ~= nil then
    id_text = id_text .. modData["_I"]
  end
  local old = self.item:getTooltip()
  if owner_text ~= getText("Tooltip_item_Owner") or id_text ~= getText("Tooltip_item_ID") then
    self.item:setTooltip(owner_text .. "\n" .. id_text)
  end
  render(self)
  self.item:setTooltip(old)
end

Events.OnPlayerMove.Add(ItemOwner.HandleFloorItem)